/*	
 *	clipmisc.h
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Wed Dec 12 21:51:29 JST 2001 Naoyuki Sawa
 *	- ϡ
 */
#include "clipstd.h"
#include "clipmisc.h"

/*****************************************************************************
 *	
 *****************************************************************************/

#ifdef PIECE
#define KSNO_LCDDrawObject 100	/* pceLCDDrawObjectΥͥ륵ӥֹ */
#endif /*PIECE*/

/*****************************************************************************
 *	Хѿ
 *****************************************************************************/

#ifdef PIECE
/* S1C33 Family CѥѥåǤϡerrnoϥץꥱ¦ɬפޤ
 * [S5U1C33000C_J.pdf p.140]
 */
int errno;
static int (*old_LCDDrawObject)(DRAW_OBJECT);	/* ʪpceLCDDrawObject¸ */
#endif /*PIECE*/

/*****************************************************************************
 *	ѿ
 *****************************************************************************/

#ifdef PIECE
/* ץཪλ˼¹ԤؿؤΥݥ󥿡
 * atexit()Ͽޤ(ߤμǤϰ٤ΤߤǤ)
 * NULLʤ顢ޤϿƤޤ
 */
static void (*exit_func)();
#endif /*PIECE*/

/*****************************************************************************
 *	顼
 *****************************************************************************/

void
die(const char* fmt, ...)
{
#ifdef PIECE
	asm("
	xcall pceLCDDispStop		; pceLCDDispStop();
	xld.w %r12, _def_vbuff		; pceLCDSetBuffer(_def_vbuff);
	xcall pceLCDSetBuffer
	xcall pceLCDDispStart		; pceLCDDispStart();
	xld.w %r12, 0			; pceFontSetType(0);
	xcall pceFontSetType
	xld.w %r12, 3			; pceFontSetTxColor(3);
	xcall pceFontSetTxColor
	xld.w %r12, 0			; pceFontSetBkColor(0);
	xcall pceFontSetBkColor
	xld.w %r12, 0			; pceFontSetPos(0, 0);
	xld.w %r13, 0
	xcall pceFontSetPos
	xld.w %r4, die_L10		; pceFontPrintf(fmt, ...);
	xld.w [%sp], %r4
	xjp pceFontPrintf
die_L10:
	xcall pceLCDTrans		; pceFontLCDTrans();
die_L20:				; for(;;) {
	xcall yield			;	yield();
	xcall pcePadGet			;	if(pcePadGet() & TRG_START) {
	xand %r10, %r10, 0x8000		;
	xjreq die_L30			;
	xld.w %r12, 1			;		pceAppReqExit(1);
	xcall pceAppReqExit		;
die_L30:				;	}
	xjp die_L20			; }
	");
#else /*PIECE*/
	va_list ap;
	va_start(ap, fmt);
	fprintf(stderr, fmt, ap);
	fprintf(stderr, "\n");
	va_end(ap);
	abort();
#endif /*PIECE*/
}

#ifdef PIECE
/*****************************************************************************
 *	P/ECEѡmainե졼
 *****************************************************************************/

static void app_proc();
static void app_exit();

/* * ѥ쥸Τ¸ɬפΤϡr0r3ΤߤǤ
 *   [S5U1C33000C_J.pdf p.84]
 */
typedef struct _CONTEXT {
	int r0, r1, r2, r3;
	int* sp;
} CONTEXT;
/* * system_contextuser_contextϡstaticѿȤƤ⤤ΤǤ
 *   Cѥϡasm֥åѿƤ뤳ȤȽǤǤ
 *   "system_contextƤ뤬ȤƤʤ"ȷٹ𤷤ޤ
 *   ϡٹΤˡХѿȤ뤳Ȥˤޤ
 */
CONTEXT system_context;	/* ƥॳƥ¸ */
CONTEXT user_context;	/* 桼ƥ¸ */

void
pceAppInit()
{
	/* 桼ƥȤޤ */
	user_context.sp = (int*)0x1C00;		/* 10001C00:桼å(3KB) */
						/* 1C002000:ƥॹå(1KB) */
	*--user_context.sp = (int)app_exit;	/* main()֤˸ƤФؿ */
	*--user_context.sp = (int)main;		/* ץꥱȥݥ */
}

void
pceAppProc(int count)
{
	/* yield()ȥåե졼ι碌ɬפΤǡ
	 * ʤδؿͳޤ
	 */
	app_proc();
}

void
pceAppExit()
{
	/* atexit()Ͽ줿λֿСƤӽФޤ */
	if(exit_func != NULL) exit_func();
}

void
app_proc()
{
	asm("
	; ƥॳƥȤ򤷤ޤ
	xld.w %r7, system_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; 桼ƥȤޤ
	xld.w %r7, user_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

static void
app_exit()
{
	asm("
	; ƥॳƥȤޤ
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4

	; λ׵ȯԤޤ
	ld.w %r12, %r10
	xcall pceAppReqExit
	");
}

void
yield()
{
	asm("
	; 桼ƥȤ򤷤ޤ
	xld.w %r7, user_context
	ld.w [%r7]+, %r0
	ld.w [%r7]+, %r1
	ld.w [%r7]+, %r2
	ld.w [%r7]+, %r3
	ld.w %r4, %sp
	ld.w [%r7]+, %r4

	; ƥॳƥȤޤ
	xld.w %r7, system_context
	ld.w %r0, [%r7]+
	ld.w %r1, [%r7]+
	ld.w %r2, [%r7]+
	ld.w %r3, [%r7]+
	ld.w %r4, [%r7]+
	ld.w %sp, %r4
	");
}

int
atexit(void (*func )())
{
	/* ߤμǤϡܤϼԤޤ */
	if(exit_func != NULL) return -1;

	/* ؿݥ󥿤Ǽޤ */
	exit_func = func;

	return 0;
}

/****************************************************************************
 *	®pceLCDDrawObject
 ****************************************************************************/

static int
new_LCDDrawObject(DRAW_OBJECT obj)
{
	PIECE_VRAM dest;
	PIECE_BMP src;
	int n, x, y, step, dest_stride, src_stride;
	unsigned char *dest_buf, *src_mask, mask;
	unsigned short *src_buf, pixel;

	/* ñžǤʤСʪǤޤ */
	if(obj.param != DRW_NOMAL) return old_LCDDrawObject(obj);

	/* žӥåȥޥå׾
	 * 2bitޥդӥåȥޥåפǤʤСʪǤޤ
	 */
	src = *obj.src;
	if(src.header.bpp != 2 || src.header.mask != 1) return old_LCDDrawObject(obj);

	/* žVRAM */
	if(obj.dest != NULL) {
		dest = *obj.dest;
	} else {
		dest.w = DISP_X;
		dest.h = DISP_Y;
		dest.buf = pceLCDSetBuffer(INVALIDPTR);
	}

	/* ž襯åԥ󥰡 */
	if(obj.dx < obj.clip.left) {
		n = obj.clip.left - obj.dx; /* ˤϤ߽Фԥ */
		obj.dx = obj.clip.left;
		obj.dw -= n;
		obj.sx += n;
	}
	if(obj.dx + obj.dw > obj.clip.right) {
		obj.dw = obj.clip.right - obj.dx;
	}
	if(obj.dw <= 0) return 0; /* ̳ */
	if(obj.dy < obj.clip.top) {
		n = obj.clip.top - obj.dy; /* ˤϤ߽Фԥ */
		obj.dy = obj.clip.top;
		obj.dh -= n;
		obj.sy += n;
	}
	if(obj.dy + obj.dh > obj.clip.bottom) {
		obj.dh = obj.clip.bottom - obj.dy;
	}
	if(obj.dh <= 0) return 0; /* ̳ */

	/* žåԥ󥰤ϹԤޤ
	 * ꤵ줿žžӥåȥޥå˼ޤäƤʤС
	 * ž襯åԥ󥰤ˤäžϤ߽ФȤϤꤨʤǤ
	 * ʪžåԥ󥰤ԤäƤΤǡߴǤ
	 */

	/* žԥ륢ɥ쥹ޤ */
	dest_buf = dest.buf + dest.w * obj.dy + obj.dx;
	dest_stride = dest.w  /* 饤󥹥ȥ饤 */
		    - obj.dw; /* Ԥǲʤफ */

	/* žԥ륢ɥ쥹ޤ */
	n = (src.header.w * obj.sy + obj.sx) / 8;
	src_buf = (unsigned short*)src.buf + n;
	src_mask = src.mask + n;
	src_stride = (src.header.w + 7) / 8           /* 饤󥹥ȥ饤 */
	           - ((obj.sx & 7) + obj.dw - 1) / 8; /* Ԥǲʤफ */
	/*                                  ~~~ 8ƥå״λ˿ʤΤǤϤʤ9ƥåܤƬǿʤफ */

	y = obj.dh; /* Ĥ饤 */
	do {
		/* 8ԥñ̤Τԥܤ鳫Ϥ뤫 */
		step = obj.sx & 7;

		/* Ϥޤ뤫椫Ϥޤ뤫狼ʤΤǡ
		 * ϤȤstep=0Ǥ⡢ǺǽΥǡ뤳Ȥˤޤ
		 * P/ECEӥåȥޥåפΥԥ¤ӤϡMSB¦ΥԥʤǤ͡
		 *   S1C33ϥȥ륨ǥʤ顢LSB¦򺸤Υԥˤ䤹ȻפΤǤ
		 *   WindowsBMPMSB¦ΥԥʤΤʡ⤷ʤСBMPλͤ˹碌ΤΤޤ
		 */
		pixel = *src_buf;	/* ԥ¤Ӥ MSB:45670123:LSB νǤ */
		mask = *src_mask;	/* ԥ¤Ӥ MSB:01234567:LSB νǤ */

		/* ԥܤ鳫Ϥ뤫ˤäơŬڤʰ֤ӹߤޤ */
		x = obj.dw; /* Ĥԥ */
		switch(step) {
LOOP: /* Ϥӱۤޤ */
			/* 8ԥñ̤γǡΥǡޤ */
			pixel = *++src_buf;
			mask = *++src_mask;
#define PIXEL(p, m) \
			/* Ʃԥʤ顢ޤ */ \
			if(mask >> (m) & 1) *dest_buf = pixel >> (p) * 2 & 3; \
			dest_buf++; \
			/* 1饤žλ顢ȴޤ */ \
			if(--x == 0) break;
		case 0: PIXEL(3, 7);
		case 1: PIXEL(2, 6);
		case 2: PIXEL(1, 5);
		case 3: PIXEL(0, 4);
		case 4: PIXEL(7, 3);
		case 5: PIXEL(6, 2);
		case 6: PIXEL(5, 1);
		default/*7*/: PIXEL(4, 0); goto LOOP;
#undef PIXEL
		}

		/* ž衦žԥ륢ɥ쥹򼡤Υ饤ؿʤޤ */
		dest_buf += dest_stride;
		src_buf += src_stride;
		src_mask += src_stride;
	} while(--y != 0);

	return 1;
}

void
hook_LCDDrawObject()
{
	/* pceLCDDrawObjectեåޤ */
	old_LCDDrawObject = pceVectorSetKs(KSNO_LCDDrawObject, new_LCDDrawObject);
}

void
unhook_LCDDrawObject()
{
	/* pceLCDDrawObjectեåޤ */
	pceVectorSetKs(KSNO_LCDDrawObject, old_LCDDrawObject);
}

#endif /*PIECE*/
